function [_n,_stiva]=inserare_element(n,stiva)
  //disp('aici inserare element');
  _n = n;
  _stiva = stiva;

	labels=['Partea reala';'Partea imaginara'];
	[ok,val_re,val_im]=getvalue('Inserare element',labels,...
      		list('vec',1,'vec',1),['';'']);
	if ok == %T then
		_n = _n + 1;
		[modul,argument] = modsiarg(val_re,val_im);
		if _n==1 then
			_stiva = [_n val_re val_im modul argument];
		else
			_stiva = [_stiva;[_n val_re val_im  modul argument]];
		end;
		reset_view(_n,_stiva);
	end;
return;
endfunction

function [_n,_stiva]=stergere_element(n,stiva)
	_n = n;
	_stiva = stiva;
	if _n > 0 then
		_n = _n-1;
		_stiva = _stiva(1:_n,:);
		reset_view(_n,stiva);
	else
		x_message(['Stiva este goala!!!'],['Ok']);
	end;
return;
endfunction

function [_n,_stiva]=repeta_varf(n,stiva)
	_n = n;
        _stiva = stiva;
	if _n > 0 then
                _stiva = [_stiva;_stiva(_n,:)];
		_n = _n + 1;
		_stiva(_n,1) = _n;
                reset_view(_n,_stiva);
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
return;
endfunction

function [_n,_stiva]=opus(n,stiva)
	_n = n;
        _stiva = stiva;
	if _n > 0 then
                _stiva(_n,2) = -_stiva(_n,2);
                _stiva(_n,3) = -_stiva(_n,3);
		[modul,argument] = modsiarg(_stiva(_n,2),_stiva(_n,3));
                _stiva(_n,4) = modul;
                _stiva(_n,5) = argument;
                reset_view(_n,_stiva);
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
return;
endfunction

function [_n,_stiva]=invers(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 0 then
		if _stiva(_n,4) ~= 0 then
			invers = 1/(_stiva(_n,2)+%i*_stiva(_n,3));
                	_stiva(_n,2) = real(invers);
			_stiva(_n,3) = imag(invers);
			[modul,argument] = modsiarg(_stiva(_n,2),_stiva(_n,3));
			_stiva(_n,4) = modul;
			_stiva(_n,5) = argument;
	                reset_view(_n,_stiva);
		else
			x_message(['Ultima valoare are modul zero !!!'],['Ok']);
		end;
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
return;
endfunction

function [_n,_stiva]=conjugat(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 0 then
                _stiva(_n,3) = -_stiva(_n,3);
		[modul,argument] = modsiarg(_stiva(_n,2),_stiva(_n,3));
                _stiva(_n,4) = modul;
                _stiva(_n,5) = argument;
                reset_view(_n,_stiva);
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
return;
endfunction

function [_n,_stiva]=adunare(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
                _stiva(_n-1,2) = _stiva(_n-1,2)+_stiva(_n,2);
                _stiva(_n-1,3) = _stiva(_n-1,3)+_stiva(_n,3);
		[modul,argument] = modsiarg(_stiva(_n-1,2),_stiva(_n-1,3));
                _stiva(_n-1,4) = modul;
                _stiva(_n-1,5) = argument;
		_n = _n -1;
		_stiva=_stiva(1:_n,:);
                reset_view(_n,_stiva);
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
return;
endfunction
 
function [_n,_stiva]=scadere(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
                _stiva(_n-1,2) = _stiva(_n-1,2)-_stiva(_n,2);
                _stiva(_n-1,3) = _stiva(_n-1,3)-_stiva(_n,3);
		[modul,argument] = modsiarg(_stiva(_n-1,2),_stiva(_n-1,3));
		_stiva(_n-1,4) = modul;
                _stiva(_n-1,5) = argument;
		_n = _n -1;
                _stiva=_stiva(1:_n,:);
                reset_view(_n,_stiva);
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
return;
endfunction

function [_n,_stiva]=inmultire(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
	        rez = (_stiva(_n-1,2)+%i*_stiva(_n-1,3))*(_stiva(_n,2)+%i*_stiva(_n,3));
                _stiva(_n-1,2) = real(rez);
		_stiva(_n-1,3) = imag(rez);
		[modul,argument] = modsiarg(_stiva(_n-1,2),_stiva(_n-1,3));
		_stiva(_n-1,4) = modul;
                _stiva(_n-1,5) = argument;
                _n = _n -1;
                _stiva=_stiva(1:_n,:);
                reset_view(_n,_stiva);
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
return;
endfunction
 
function [_n,_stiva]=impartire(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
		if (_stiva(_n,2) ~= 0 | _stiva(_n,3) ~= 0) then
			rez = (_stiva(_n-1,2)+%i*_stiva(_n-1,3))/(_stiva(_n,2)+%i*_stiva(_n,3));
                	_stiva(_n-1,2) = real(rez);
                	_stiva(_n-1,3) = imag(rez);
			[modul,argument] = modsiarg(_stiva(_n-1,2),_stiva(_n-1,3));
			_stiva(_n-1,4) = modul;
                	_stiva(_n-1,5) = argument;
        	        _n = _n -1;
                	_stiva=_stiva(1:_n,:);
	                reset_view(_n,_stiva);
		else
			x_message(['Ultima valoare este nula!!!'],['Ok']);
		end;
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
return;
endfunction      

function [modul,argument] = modsiarg(valre,vali)
modul = abs(valre + %i*vali);
if modul ~= 0
	argument = atan(vali,valre);
else
	argument = 0;
end
return
endfunction

